package space.eptaproject.vmodextras.compact.computercraft;

import dan200.computercraft.api.lua.IArguments;
import dan200.computercraft.api.lua.LuaException;
import dan200.computercraft.api.lua.LuaFunction;
import dan200.computercraft.api.peripheral.IComputerAccess;
import dan200.computercraft.api.peripheral.IPeripheral;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import lombok.AllArgsConstructor;
import org.joml.Vector3d;
import org.joml.Vector3dc;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodextras.trackwork.ISimpleWheelController;

import java.util.List;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

@AllArgsConstructor
public class TrackWorkControllerPeripheral implements IPeripheral {
    private final List<IComputerAccess> connectedComputers = new ObjectArrayList<>();

    private TrackWorkControllerEntity entity;

    @Override
    public @Nonnull String getType() {
        return "track_work_controller";
    }

    public boolean equals(IPeripheral iPeripheral) {
        return this == iPeripheral;
    }

    @Override
    public void detach(@Nullable IComputerAccess computer) {
        connectedComputers.remove(computer);
    }

    @Override
    public void attach(@Nonnull IComputerAccess computer) {
        connectedComputers.add(computer);
    }

    @LuaFunction
    public final void SetSuspensionAdjust(IArguments arguments) throws LuaException {
        Vector3dc vec = new Vector3d(arguments.getDouble(0),arguments.getDouble(1),arguments.getDouble(2));

        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.entity.getLevel(), this.entity.getBlockPos());
        if (ship != null) {
            ((ISimpleWheelController) SimpleWheelController.getOrCreate(ship)).setSuspensionAdjust(vec);
        }
    }

    @LuaFunction
    public final void GetSuspensionAdjust(IArguments arguments) throws LuaException {

    }
}
